local utils = import "utils.libsonnet";

{
  global: {
    // .gitlab-ci.yaml top `variables` key
    FAILFASTCI_NAMESPACE: "quay",
  },

  // internal variables
  images: {
    // Quay initial image, used in the FROM clause
    base: { repo: "quay.io/quay/quay-base", tag: "latest",
            name: utils.containerName(self.repo, self.tag),
    },

    // @TODO(ant31) release should use quay/quay
    // release is a copy of the quayci image to the 'prod' repository
    release: { repo: "quay.io/quay/quay",
               tag: "${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHA}",
               name: utils.containerName(self.repo, self.tag),
    },

    quayci: { repo: "quay.io/quay/quay-ci", tag: "${CI_COMMIT_REF_SLUG}",
              name: utils.containerName(self.repo, self.tag),
    },
  },
}
